> For the complete documentation index, see [llms.txt](https://renewables.docs.helinplatform.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://renewables.docs.helinplatform.com/api-reference/nodes.md).

# Nodes

## Nodes

> List all nodes.\
> \
> Returns:\
> &#x20;   List of nodes.

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"security":[{"Auth0HTTPBearer":[]}],"components":{"securitySchemes":{"Auth0HTTPBearer":{"scheme":"bearer","type":"http"}},"schemas":{"NodeResponse":{"properties":{"configuration":{"additionalProperties":true,"nullable":true,"title":"Configuration","type":"object"},"created_at":{"format":"date-time","title":"Created At","type":"string"},"curtail_in_batch":{"nullable":true,"title":"Curtail In Batch","type":"boolean"},"curtailment_module_config":{"additionalProperties":true,"nullable":true,"title":"Curtailment Module Config","type":"object"},"id":{"format":"uuid","title":"Id","type":"string"},"meta_data":{"additionalProperties":true,"nullable":true,"title":"Meta Data","type":"object"},"platform_instance":{"nullable":true,"title":"Platform Instance","type":"string"},"polaris_node_name":{"title":"Polaris Node Name","type":"string"},"site_id":{"format":"uuid","title":"Site Id","type":"string"}},"required":["polaris_node_name","site_id","meta_data","curtailment_module_config","id","created_at"],"title":"NodeResponse","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"}}},"paths":{"/nodes":{"get":{"description":"List all nodes.\n\nReturns:\n    List of nodes.","operationId":"Nodes_api_nodes_get","parameters":[{"in":"header","name":"X-Management-Token","required":false,"schema":{"nullable":true,"title":"X-Management-Token","type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/NodeResponse"},"title":"Response Nodes Api Nodes Get","type":"array"}}},"description":"Successful Response"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"}},"summary":"Nodes","tags":["nodes"]}}}}
```

## Node Metadata

> Get node metadata details.\
> \
> Returns:\
> &#x20;   Node metadata details.\
> &#x20;   HTTP 404 if node not found.

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"security":[{"Auth0HTTPBearer":[]}],"components":{"securitySchemes":{"Auth0HTTPBearer":{"scheme":"bearer","type":"http"}},"schemas":{"NodeMetadataResponse":{"properties":{"node_path":{"title":"Node Path","type":"string"}},"required":["node_path"],"title":"NodeMetadataResponse","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"}}},"paths":{"/nodes/metadata/{node_name}":{"get":{"description":"Get node metadata details.\n\nReturns:\n    Node metadata details.\n    HTTP 404 if node not found.","operationId":"Node_metadata_api_nodes_metadata__node_name__get","parameters":[{"in":"path","name":"node_name","required":true,"schema":{"title":"Node Name","type":"string"}},{"in":"header","name":"X-Management-Token","required":false,"schema":{"nullable":true,"title":"X-Management-Token","type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/NodeMetadataResponse"}}},"description":"Successful Response"},"404":{"content":{"application/json":{"schema":{"properties":{"detail":{"items":{"type":"string"},"title":"Detail","type":"array"}},"title":"Object not found","type":"object"}}},"description":"Object not found"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"}},"summary":"Node Metadata","tags":["nodes"]}}}}
```

## Node Details

> Get node details.\
> \
> Returns:\
> &#x20;   Node details.\
> &#x20;   HTTP 404 if node not found.

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"security":[{"Auth0HTTPBearer":[]}],"components":{"securitySchemes":{"Auth0HTTPBearer":{"scheme":"bearer","type":"http"}},"schemas":{"NodeResponse":{"properties":{"configuration":{"additionalProperties":true,"nullable":true,"title":"Configuration","type":"object"},"created_at":{"format":"date-time","title":"Created At","type":"string"},"curtail_in_batch":{"nullable":true,"title":"Curtail In Batch","type":"boolean"},"curtailment_module_config":{"additionalProperties":true,"nullable":true,"title":"Curtailment Module Config","type":"object"},"id":{"format":"uuid","title":"Id","type":"string"},"meta_data":{"additionalProperties":true,"nullable":true,"title":"Meta Data","type":"object"},"platform_instance":{"nullable":true,"title":"Platform Instance","type":"string"},"polaris_node_name":{"title":"Polaris Node Name","type":"string"},"site_id":{"format":"uuid","title":"Site Id","type":"string"}},"required":["polaris_node_name","site_id","meta_data","curtailment_module_config","id","created_at"],"title":"NodeResponse","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"}}},"paths":{"/nodes/{node_id}":{"get":{"description":"Get node details.\n\nReturns:\n    Node details.\n    HTTP 404 if node not found.","operationId":"Node_details_api_nodes__node_id__get","parameters":[{"in":"path","name":"node_id","required":true,"schema":{"format":"uuid","title":"Node Id","type":"string"}},{"in":"header","name":"X-Management-Token","required":false,"schema":{"nullable":true,"title":"X-Management-Token","type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/NodeResponse"}}},"description":"Successful Response"},"404":{"content":{"application/json":{"schema":{"properties":{"detail":{"items":{"type":"string"},"title":"Detail","type":"array"}},"title":"Object not found","type":"object"}}},"description":"Object not found"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"}},"summary":"Node Details","tags":["nodes"]}}}}
```

## Node Rest Relay

> Forward an arbitrary HTTP request through the edge module's REST relay.\
> \
> The request is delivered to the node via the \`\`rest\_request\`\` IoT Hub direct\
> method and the remote HTTP response (status code, headers, body) is returned.\
> \
> Returns:\
> &#x20;   The HTTP response received by the edge module.\
> &#x20;   HTTP 404 if the node is not found.\
> &#x20;   HTTP 502 if the edge module is unreachable or returned an error.

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"security":[{"Auth0HTTPBearer":[]}],"components":{"securitySchemes":{"Auth0HTTPBearer":{"scheme":"bearer","type":"http"}},"schemas":{"RestRelayRequest":{"description":"Wrapper for OpenEMS API rest request forwarded to curtailment container","properties":{"body":{"additionalProperties":true,"nullable":true,"title":"Body","type":"object"},"headers":{"additionalProperties":{"type":"string"},"nullable":true,"title":"Headers","type":"object"},"method":{"enum":["GET","POST","PUT","PATCH","DELETE"],"title":"Method","type":"string"},"password":{"nullable":true,"title":"Password","type":"string"},"path":{"title":"Path","type":"string"},"query_params":{"additionalProperties":{"type":"string"},"nullable":true,"title":"Query Params","type":"object"},"username":{"nullable":true,"title":"Username","type":"string"}},"required":["method","path"],"title":"RestRelayRequest","type":"object"},"RestRelayResponse":{"description":"Response returned by the edge ``rest_request`` direct method.","properties":{"body":{"title":"Body"},"headers":{"additionalProperties":true,"title":"Headers","type":"object"},"status_code":{"title":"Status Code","type":"integer"}},"required":["status_code","headers","body"],"title":"RestRelayResponse","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"}}},"paths":{"/nodes/{node_id}/rest-relay":{"post":{"description":"Forward an arbitrary HTTP request through the edge module's REST relay.\n\nThe request is delivered to the node via the ``rest_request`` IoT Hub direct\nmethod and the remote HTTP response (status code, headers, body) is returned.\n\nReturns:\n    The HTTP response received by the edge module.\n    HTTP 404 if the node is not found.\n    HTTP 502 if the edge module is unreachable or returned an error.","operationId":"Node_REST_relay_api_nodes__node_id__rest_relay_post","parameters":[{"in":"path","name":"node_id","required":true,"schema":{"format":"uuid","title":"Node Id","type":"string"}},{"in":"header","name":"X-Management-Token","required":false,"schema":{"nullable":true,"title":"X-Management-Token","type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestRelayRequest"}}},"required":true},"responses":{"200":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestRelayResponse"}}},"description":"Successful Response"},"404":{"content":{"application/json":{"schema":{"properties":{"detail":{"items":{"type":"string"},"title":"Detail","type":"array"}},"title":"Object not found","type":"object"}}},"description":"Object not found"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"},"502":{"description":"Edge module unreachable or returned an error"}},"summary":"Node Rest Relay","tags":["nodes"]}}}}
```

## Nodes On A Site

> List all nodes from a given site.\
> \
> Returns:\
> &#x20;   List of nodes.\
> &#x20;   HTTP 404 if Site not found.

```json
{"openapi":"3.0.3","info":{"title":"POLARIS Curtailment API","version":"0.1"},"security":[{"Auth0HTTPBearer":[]}],"components":{"securitySchemes":{"Auth0HTTPBearer":{"scheme":"bearer","type":"http"}},"schemas":{"NodeResponse":{"properties":{"configuration":{"additionalProperties":true,"nullable":true,"title":"Configuration","type":"object"},"created_at":{"format":"date-time","title":"Created At","type":"string"},"curtail_in_batch":{"nullable":true,"title":"Curtail In Batch","type":"boolean"},"curtailment_module_config":{"additionalProperties":true,"nullable":true,"title":"Curtailment Module Config","type":"object"},"id":{"format":"uuid","title":"Id","type":"string"},"meta_data":{"additionalProperties":true,"nullable":true,"title":"Meta Data","type":"object"},"platform_instance":{"nullable":true,"title":"Platform Instance","type":"string"},"polaris_node_name":{"title":"Polaris Node Name","type":"string"},"site_id":{"format":"uuid","title":"Site Id","type":"string"}},"required":["polaris_node_name","site_id","meta_data","curtailment_module_config","id","created_at"],"title":"NodeResponse","type":"object"},"HTTPValidationError":{"properties":{"detail":{"items":{"$ref":"#/components/schemas/ValidationError"},"title":"Detail","type":"array"}},"title":"HTTPValidationError","type":"object"},"ValidationError":{"properties":{"loc":{"items":{"anyOf":[{"type":"string"},{"type":"integer"}]},"title":"Location","type":"array"},"msg":{"title":"Message","type":"string"},"type":{"title":"Error Type","type":"string"}},"required":["loc","msg","type"],"title":"ValidationError","type":"object"}}},"paths":{"/sites/{site_id}/nodes":{"get":{"description":"List all nodes from a given site.\n\nReturns:\n    List of nodes.\n    HTTP 404 if Site not found.","operationId":"Nodes_on_a_site_api_sites__site_id__nodes_get","parameters":[{"in":"path","name":"site_id","required":true,"schema":{"format":"uuid","nullable":true,"title":"Site Id","type":"string"}},{"in":"header","name":"X-Management-Token","required":false,"schema":{"nullable":true,"title":"X-Management-Token","type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"items":{"$ref":"#/components/schemas/NodeResponse"},"title":"Response Nodes On A Site Api Sites  Site Id  Nodes Get","type":"array"}}},"description":"Successful Response"},"404":{"content":{"application/json":{"schema":{"properties":{"detail":{"items":{"type":"string"},"title":"Detail","type":"array"}},"title":"Object not found","type":"object"}}},"description":"Object not found"},"422":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/HTTPValidationError"}}},"description":"Validation Error"}},"summary":"Nodes On A Site","tags":["nodes"]}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://renewables.docs.helinplatform.com/api-reference/nodes.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
